#!/usr/bin/ruby
require 'webrick'
require 'needle'
require 'amritahandler'
include WEBrick

$DEBUG = true

s = HTTPServer.new(
  :Port            => 2000,
  :DocumentRoot    => Dir::pwd,
  :DirectoryListEnable => true
)

load_rb = [
  'webapp/add.rb',
  'webapp/list.rb',
  'webapp/listaction.rb'
]

Webapp = Module.new
load_rb.each do |rb|
  File::open(rb) do |f|
    Webapp.module_eval(f.read)
  end
end
p Webapp.constants if $DEBUG
Webapp.constants.each do |const|
  clazz = Webapp.const_get(const)
  if clazz.instance_of?(Class)
    if clazz.const_defined?(:ATTR_INPUT)
      attrs = clazz.const_get(:ATTR_INPUT)
      attrs.each do |a|
        method = a.to_s
        clazz.module_eval %Q{
          def #{method}(m = nil)
            m.#{method}('', :value=>@#{method}) if m
            @#{method}
          end
        }
      end
    end
    if clazz.const_defined?(:ATTR_ACTION_INPUT)
      attrs = clazz.const_get(:ATTR_ACTION_INPUT)
      attrs.each do |a|
        method = a.to_s
        clazz.module_eval %Q{
          def #{method}(m = nil)
            m.#{method}('', :value=>@#{method}, :name=>"#{method}_\#{__id__}") if m
            @#{method}
          end
        }
      end
    end
    if clazz.const_defined?(:ATTR_ACTION_SELECT)
      attrs = clazz.const_get(:ATTR_ACTION_SELECT)
      attrs.each do |a|
        method = a.to_s
        clazz.module_eval %Q{
          def #{method}(m = nil)
            m.#{method}('', :value=>@#{method}, :name=>"#{method}_\#{__id__}") if m
            @#{method}
          end
        }
      end
    end
  end
end

# bI[u
$registry = Needle::Registry.new
$registry.register(:add) { Webapp::Add.new }
$registry.register(:list) { Webapp::List.new }
$registry.register(:listaction, :model => :prototype) {|c, p| Webapp::ListAction.new(c.list) }
$registry.register(:init) do |c, p|
   c.add
   c.list
   c.listaction
end
$registry.init

AmritaHandler::CONFIG[:FancyIndexing] = true
s.mount('/webapp', HTTPServlet::FileHandler, 'webapp', AmritaHandler::CONFIG)

Signal.trap(:INT){ s.shutdown }
Signal.trap(:TERM){ s.shutdown }
s.start
